#include "game.h"

#define iNil 32767 /* a distinguished value like nil */
#define  maxGroup 512
#define  maxSPoint (thegame.boardSize - 3)
#define tryLimit 300

/*Return a letter corresponding to column x; 'i' is omitted from letter */
/* sequence by tradition.*/
#define lettercol(x) (                                                  \
		      (0<=(x)&&(x)<=7) ? 'a'+(x) : (7<(x)&&(x)< thegame.boardSize) ? 'a'+(x)+1 :  \
		    		'@')
//				This character replaces the call
//		                panic("illegal lettercol()") )
//				to avoid compilation errors with g++

/*Convert any uppercase letter to lowercase.*/
#define lowercase(c) ('A'<=(c)&&(c)<='Z'?(c)-'A'+'a':(c))


typedef short intBoard[maxSIZE][maxSIZE];  /* these were -2 to maxPoint + 2 */

typedef short boolBoard[maxSIZE][maxSIZE];

typedef struct
{
   short px, py;
} point;

typedef struct
{
   point p[401];
   short indx;
} pointList;

typedef struct
{
  point p[maxSIZE+1];
  short indx;
} sPointList;

typedef struct
{
   short indx,
   v[401];
} intList;
   
typedef struct { short w, s, sm; } sgRec;

typedef struct
{
   short groupMark,
         atLevel,
	 isLive,
	 isDead,
	 libC,
	 numEyes,
	 size,
	 lx, ly;
} groupRec;

typedef enum {rem, add, chLib, reMap} playType;

typedef struct { short who, xl, yl, nextGID, sNumber; } remAddRec;
typedef struct { short oldLC, oldLevel; } chLibRec;
typedef struct { short oldGID; } reMapRec;
typedef struct
{
   short gID;
   playType kind;
   union {
      remAddRec rem, add;
      chLibRec chLib;
      reMapRec reMap;
   } uval;
} playRec;

